=== debian/changelog ===
ruby-grpc (1.3.2+debian-4build1) bionic; urgency=medium

  * No-change rebuild

 -- Jeremy Bicha <jbicha@ubuntu.com>  Mon, 02 Apr 2018 20:18:57 -0400

ruby-grpc (1.3.2+debian-4) unstable; urgency=medium

  * Fix cflags (Thanks to Steve Langasek) (Closes: #873440)
  * Bump standards version to 4.1.3
  * Bump debhelper compat to 11

 -- Pirate Praveen <praveen@debian.org>  Wed, 21 Feb 2018 19:41:16 +0530

ruby-grpc (1.3.2+debian-3) unstable; urgency=medium

  * ruby-grpc-tools: Fix protoc path and add protobuf-compiler-grpc as build
    dependency

 -- Pirate Praveen <praveen@debian.org>  Sat, 05 Aug 2017 00:10:10 +0530

ruby-grpc (1.3.2+debian-2) unstable; urgency=medium

  * Add new binary package: ruby-grpc-tools 

 -- Pirate Praveen <praveen@debian.org>  Fri, 04 Aug 2017 23:08:06 +0530

ruby-grpc (1.3.2+debian-1) unstable; urgency=medium

  * Initial release (Closes: #863252)

 -- Pirate Praveen <praveen@debian.org>  Wed, 24 May 2017 18:17:09 +0530
