=== debian/control ===
Source: ruby-grpc
Section: ruby
Priority: optional
Maintainer: Debian Ruby Extras Maintainers <pkg-ruby-extras-maintainers@lists.alioth.debian.org>
Uploaders: Pirate Praveen <praveen@debian.org>
Build-Depends: debhelper (>= 11~),
               gem2deb,
               ruby-google-protobuf (>= 3.1),
               ruby-googleauth (>= 0.5.1),
               libssl-dev,
               zlib1g-dev,
               libc-ares-dev,
               libgrpc-dev,
               ruby-rspec,
               ruby-simplecov
Standards-Version: 4.1.3
Vcs-Git: https://anonscm.debian.org/git/pkg-ruby-extras/ruby-grpc.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ruby-extras/ruby-grpc.git
Homepage: https://github.com/google/grpc/tree/master/src/ruby
Testsuite: autopkgtest-pkg-ruby
XS-Ruby-Versions: all

Package: ruby-grpc
Architecture: any
X-DhRuby-Root: .
XB-Ruby-Versions: ${ruby:Versions}
Depends: ruby | ruby-interpreter,
         ruby-google-protobuf (>= 3.1),
         ruby-googleauth (>= 0.5.1),
         ${misc:Depends},
         ${shlibs:Depends}
Description: GRPC system in Ruby
 Send RPCs from Ruby using GRPC. GRPC is a high performance, open-source
 universal RPC framework.
 .
 Some features of gRPC:
  * Simple service definition
  * Works across languages and platforms
  * Start quickly and scale
  * Bi-directional streaming and integrated auth

Package: ruby-grpc-tools
Architecture: all
X-DhRuby-Root: src/ruby/tools
XB-Ruby-Versions: ${ruby:Versions}
Depends: ruby | ruby-interpreter,
         ruby-grpc,
         protobuf-compiler-grpc,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Development tools for Ruby gRPC
 Ruby gRPC library allows sending RPCs from Ruby using GRPC.
 GRPC is a high performance, open-source universal RPC framework.
