=== debian/watch ===
version=3
opts=\
repacksuffix=+debian,\
repack,compression=xz,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,\
dversionmangle=s/(\d)[\+]?(debian|dfsg|ds|deb|gh)\d*$/$1/,\
filenamemangle=s/.*\/v?([\d\.-]+)\.tar\.gz/grpc-$1.tar.gz/ \
https://github.com/google/grpc/tags .*/archive/v?([\d\.]+).tar.gz
